]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
58bf7c8e89d2a3e5a907583a11de31637cd71f2e
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # BuildRequires:        awk
59 # BuildRequires:        rpmbuild(macros) >= 1.315
60 #
61 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
62 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
63 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
64 # %rpmldflags   = %optldflags - %filterout_ld
65 #
66 # Regular expressions are supported, but to avoid some character be treated
67 # as regular expression it must be escaped twice.
68
69 %filter_out                                             \
70         for (i in I) {  A=0;                    \
71                 for (f in F) {                          \
72                         if (I[i] ~ "^" F[f] "$") A=1;   \
73                 };                                                      \
74                 if (!A) printf(I[i] FS);        \
75         }
76
77 %rpmcflags %(awk 'BEGIN {
78         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
79         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
80         %{filter_out}
81 }')
82
83 %rpmcxxflags %(awk 'BEGIN {
84         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
85         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
86         %{filter_out}
87 }')
88
89 %rpmldflags %(awk 'BEGIN {
90         split("%{?optldflags}",I);
91         split("%{?filterout_ld}",F)
92         %{filter_out}
93 }')
94
95 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
96 # but, don't use it, better use gcc as linker
97 %ld_rpmldflags %(awk 'BEGIN {
98         split("%{rpmldflags}",F);
99         for (f in F) {
100                 s = F[f];
101                 if (s ~ /^-Wl,/) {
102                         s = substr(s,5);
103                         gsub(/,/," ",s);
104                 };
105                 printf(s FS);
106         };
107 }')
108
109 #-----------------------------------------------------------------
110 %configure2_13 { \
111  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
112  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
113  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
114  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
115  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
116  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
117  %{?__cc:CC="%{__cc}" ; export CC ; } \
118  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
119  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
120         --host=%{_target_platform} \
121         --prefix=%{_prefix} \
122         --exec-prefix=%{_exec_prefix} \
123         --bindir=%{_bindir} \
124         --sbindir=%{_sbindir} \
125         --sysconfdir=%{_sysconfdir} \
126         --datadir=%{_datadir} \
127         --includedir=%{_includedir} \
128         --libdir=%{_libdir} \
129         --libexecdir=%{_libexecdir} \
130         --localstatedir=%{_localstatedir} \
131         --sharedstatedir=%{_sharedstatedir} \
132         --mandir=%{_mandir} \
133         --infodir=%{_infodir} \
134         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
135         %{dependencytracking} \
136 }
137
138 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
139 %__cmake        /usr/bin/cmake
140 %cmake { \
141 CC="%{__cc}" \
142 CXX="%{__cxx}" \
143 CFLAGS="%{rpmcflags}" \
144 CXXFLAGS="%{rpmcxxflags}" \
145 %{__cmake} \
146 }
147
148 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
149 %__scons        /usr/bin/scons
150 %scons { \
151 %{__scons} \
152 }
153
154 # waf. see waf.spec
155 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
156 %__waf  /usr/bin/waf
157 %waf { \
158 CC="%{__cc}" \
159 CXX="%{__cxx}" \
160 CPP="%{__cpp}" \
161 CFLAGS="%{rpmcflags}" \
162 CXXFLAGS="%{rpmcxxflags}" \
163 %{__waf} \
164 }
165
166 #----------------------------------------------------------------
167 %global configure_cache 0
168 %configure_cache_file   %{buildroot}.configure.cache
169
170 %configure {./configure \
171         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
172         CFLAGS="${CFLAGS:-%rpmcflags}" \
173         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
174         FFLAGS="${FFLAGS:-%rpmcflags}" \
175         CPPFLAGS="${CPPFLAGS:-}" \
176         %{?__cc:CC="%{__cc}"} \
177         %{?__cxx:CXX="%{__cxx}"} \
178         --host=%{_target_platform} \
179         --build=%{_target_platform} \
180         --prefix=%{_prefix} \
181         --exec-prefix=%{_exec_prefix} \
182         --bindir=%{_bindir} \
183         --sbindir=%{_sbindir} \
184         --sysconfdir=%{_sysconfdir} \
185         --datadir=%{_datadir} \
186         --includedir=%{_includedir} \
187         --libdir=%{_libdir} \
188         --libexecdir=%{_libexecdir} \
189         --localstatedir=%{_localstatedir} \
190         --sharedstatedir=%{_sharedstatedir} \
191         --mandir=%{_mandir} \
192         --infodir=%{_infodir} \
193         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
194         %{dependencytracking} \
195         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
196 }
197
198 # ------------------------------------------------------------------------
199 # Overloading of some basic macros
200 %prep \
201 %%prep\
202 export LC_ALL=C\
203 export LANG=C\
204 unset LINGUAS ||:\
205 unset LANGUAGE ||:\
206 unset LC_MESSAGES ||:\
207 unset DISPLAY ||:\
208 %{nil}
209
210 %build %%build\
211 export LC_ALL=C\
212 export LANG=C\
213 unset LINGUAS ||:\
214 unset LANGUAGE ||:\
215 unset LC_MESSAGES ||:\
216 unset DISPLAY ||:\
217 %{nil}
218
219 %install \
220 %if 0%{?_enable_debug_packages}\
221 %{?buildsubdir:%{debug_package}}\
222 %endif\
223 %%install\
224 export LC_ALL=C\
225 export LANG=C\
226 unset LINGUAS ||:\
227 unset LANGUAGE ||:\
228 unset LC_MESSAGES ||:\
229 unset DISPLAY ||:\
230 %{nil}
231
232 # Location of autoconf macros
233 %_aclocaldir    %(aclocal --print-ac-dir)
234
235 # Location of omf files
236 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
237
238 # Location of pkgconfig files
239 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
240
241 # Location of desktop files
242 %_desktopdir    /usr/share/applications
243 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
244
245 # Location of pixmaps for applnk/desktop files
246 %_pixmapsdir    /usr/share/pixmaps
247
248 # Location of themable icons for applnk/desktop files
249 %_iconsdir      /usr/share/icons
250
251 # Location of fonts directories
252 %_fontsdir      /usr/share/fonts
253
254 # Location of Gtk and associated libraries documentation
255 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
256
257 # Location of KDE documentation
258 %_kdedocdir     %{_defaultdocdir}/kde/HTML
259
260 # unsermake script
261 %__unsermake /usr/share/unsermake/unsermake
262
263 # Current date
264 %date           %(LC_ALL="C" date +"%a %b %d %Y")
265
266 # tmp directory
267 %tmpdir         %(echo "${TMPDIR:-/tmp}")
268
269 # Example files, programs, scripts...
270 %_examplesdir   /usr/src/examples
271
272 # Alternative kernel type/version
273 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
274
275 # The directory holding Linux kernel sources
276 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
277
278 # If non-empty "debug" macro defined, add "dbg" suffix to release number
279 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
280
281 # Requires name = version-release
282 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
283
284 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
285 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
286 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
287 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
288
289 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
290 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
291
292 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
293
294 # kernel version-release handling
295 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
296 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
297 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
298 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
299 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
300
301 # sgml macros
302 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
303 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
304 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
305 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
306 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
307 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
308 %docbook_sgmlcat_fix() { for l in \
309 '' \
310 '  -- default decl --' \
311 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
312 '  -- hacks for opensp --' \
313 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
314 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
315 '' \
316 ; do echo $l; done >> %1 \
317 }
318
319 # vim - "
320
321 # minimum file size needed for compressed documents.
322 # just smaller files than this get larger when compressed.
323 # some stats:
324 # - 0 byte file compressed was 25 bytes .gz
325 # - 39 byte file was compressed as 57
326 # - with test/test.spec@man 158 byte file was compressed also 158
327 %_min_compress_bytes    159
328
329 #-----------------------------------------------------------------
330 # find and gzip all files in %{_mandir} and %{infodir}
331 #
332 # Requires: xargs, find
333 #
334 #%no_install_post_compress_docs 1
335 %__spec_install_post_compress_docs { \
336 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
337         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
338                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
339                         echo "Compress $(basename $i) pages: $i"; \
340                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
341                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
342                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
343                 fi; \
344         done; \
345 }; __spec_install_post_compress_docs } }
346
347 #-----------------------------------------------------------------
348 # Strip executable binaries and shared object files
349 #
350 # Requires: find, awk, strip, cut, xargs
351 #
352 #%no_install_post_strip 1
353 %__spec_install_post_strip {%{!?debug: \
354 %{!?no_install_post_strip:__spec_install_post_strip() { \
355 if [ -d "$RPM_BUILD_ROOT" ]; then \
356         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
357                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
358                 printf "Stripping %d kernel modules..." $(echo "$modulelist" | wc -l); \
359                 echo "$modulelist" | xargs -l512 chmod u+w; \
360                 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
361                 echo "DONE"; \
362         fi; \
363         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
364         # vim - " \
365         if [ -z "$filelist" ]; then \
366                 return; \
367         fi; \
368         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
369         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
370         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
371         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
372         if [ -n "$elfexelist" ]; then \
373                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
374                 chmod u+w $elfexelist; \
375                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
376                 echo "DONE"; \
377         fi; \
378         if [ -n "$elfsharedlist" ]; then \
379                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
380                 chmod u+w $elfsharedlist; \
381                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
382                 echo "DONE"; \
383         fi; \
384         if [ -n "$archiveslist" ]; then \
385                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
386                 chmod u+w $archiveslist; \
387                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
388                 echo "DONE"; \
389         fi; \
390 fi; }; __spec_install_post_strip } } }
391
392 #-----------------------------------------------------------------
393 # remove all RPATH from executable binaries and shared object files
394 #
395 # Requires: find, awk, cut, xargs, chrpath, uname
396 #
397 #%no_install_post_chrpath       1
398 %__spec_install_post_chrpath {%{!?debug: \
399 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
400 if [ -d "$RPM_BUILD_ROOT" ]; then \
401         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
402         if [ -n "$files" ]; then \
403                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
404         fi
405         #"
406         if [ -n "$objs" ]; then \
407                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
408                 echo "$objs" | \
409                 while read file; do \
410                         rpath= ; \
411                         chmod u+w "$file"; \
412                         for dir in `chrpath -l "$file" | \
413                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
414                                         case $dir in \
415                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
416                                                 echo "remove-rpath: $dir in $file"; \
417                                                 ;; \
418                                         * ) \
419                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
420                                                 else rpath="$rpath:$dir" ; fi ; \
421                                                 ;; \
422                                         esac ; \
423                         done ; \
424                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
425                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
426                 done; \
427         fi; \
428 fi; }; __spec_install_post_chrpath } } }
429
430 #-----------------------------------------------------------------
431 # Find and gzip all kernel modules
432 #
433 # Requires: find
434 #
435 #%no_install_post_compress_modules      1
436 %__spec_install_post_compress_modules { \
437 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
438         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
439                 echo "Compress kernel modules"; \
440                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
441                 echo "$q" | xargs -r %{__gzip} -9nf; \
442                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
443                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
444                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
445         fi; \
446 }; __spec_install_post_compress_modules } }
447
448 # Remove common Perl files we don't package
449 %__spec_install_post_perl_clean {\
450 %{!?no_install_post_perl_clean: \
451 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
452 } }
453
454 #-----------------------------------------------------------------
455 # Update GConf2 schemas
456 #
457 # Requires: GConf2
458 #
459 %gconf_schema_install() \
460         umask 022; \
461         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
462         %{nil}
463
464 %gconf_schema_uninstall() \
465 if [ $1 = 0 ]; then \
466         umask 022; \
467         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
468 fi \
469 %{nil}
470
471 #-----------------------------------------------------------------
472 # Update desktop MIME database
473 # requires: desktop-file-utils
474 #
475 %update_desktop_database_post() {{ \
476         umask 022; \
477         /usr/bin/update-desktop-database -q; \
478 }}
479
480 %update_desktop_database_postun() {{ \
481 if [ $1 = 0 ]; then \
482         umask 022; \
483         /usr/bin/update-desktop-database -q; \
484 fi \
485 }}
486
487 #-----------------------------------------------------------------
488 # Update shared MIME info database
489 # requires: shared-mime-info
490 #
491 %update_mime_database() {{ \
492         umask 022; \
493         /usr/bin/update-mime-database %{_datadir}/mime; \
494 }}
495
496 #-----------------------------------------------------------------
497 # Update icon cache
498 # requires: gtk+
499 #
500 %update_icon_cache() {{ \
501         umask 022; \
502         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
503 }}
504
505 #-----------------------------------------------------------------
506 # Update scrollkeeper database
507 # requires: scrollkeeper
508 #
509 %scrollkeeper_update_post() \
510         /usr/bin/scrollkeeper-update -q; \
511         %{nil}
512
513 %scrollkeeper_update_postun() \
514 if [ $1 = 0 ]; then \
515         /usr/bin/scrollkeeper-update -q; \
516 fi \
517 %{nil}
518
519 #-----------------------------------------------------------------
520 # post %install sequence:
521 # - autodeps exceptions
522 # - compress all man and info pages,
523 # - strip all ELF executables and ELF shared objects if not %debug.
524 # - compress kernel modules if any
525
526 ###################################################################
527 # Requires/Provides automation
528 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
529 #
530 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
531 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
532 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
533 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
534 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
535 #%_noautocompressdoc    %{nil}
536 #
537 %_missing_doc_files_terminate_build     1%{nil}
538 %_unpackaged_files_terminate_build      %{nil}
539 # (X)emacs support
540 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
541 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
542 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
543
544 %__php_provides %{nil}
545 %__php_requires %{nil}
546 %__perl_provides %{nil}
547 %__perl_requires %{nil}
548 %__mono_provides %{nil}
549 %__mono_requires %{nil}
550
551 # Perl specific macro definitions.
552 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
553 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
554 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
555 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
556 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
557 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
558
559 # Ruby
560 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
561 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
562 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
563 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
564 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
565 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
566 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
567 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
568
569 %php_pear_dir           /usr/share/pear
570 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
571 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
572
573 # directory where php includes are installed on system.
574 %__php_includedir               /usr/include/php
575 # extract php/zend api versions
576 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
577 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
578 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
579 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
580 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
581 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
582 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
583
584 # helper macro
585 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
586
587 # macros for public use
588 # for php extensions (php-pecl)
589 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
590 %{__php_api_requires zend_module_api} \
591 %{__php_api_requires -v %php_major_version debug php_debug} \
592 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
593
594 # for zend extensions
595 %requires_zend_extension %{__php_api_requires zend_module_api} \
596 %{__php_api_requires zend_extension_api} \
597 %{__php_api_requires -v %php_major_version debug php_debug} \
598 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
599
600 # for php pdo modules (php-pecl-PDO_*)
601 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
602
603 # for using PHP post scripts. for PHP >= 5.0
604 %php_webserver_restart \
605 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
606 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
607 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
608         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
609         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
610                 %service -q php-fcgi restart \
611         fi \
612 fi \
613 %{nil}
614
615 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
616 %php4_webserver_restart \
617 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
618 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
619 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
620         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
621         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
622                 %service -q php-fcgi restart \
623         fi \
624 fi \
625 %{nil}
626
627 # Python specific macro definitions.
628 # python main version
629 %py_ver                 %(python -c "import sys; print sys.version[:3]")
630
631 # directories
632 %py_prefix              %(python -c "import sys; print sys.prefix")
633 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
634 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
635 %py_incdir              /usr/include/python%{py_ver}
636 %py_sitedir             %{py_libdir}/site-packages
637 %py_sitescriptdir %{py_scriptdir}/site-packages
638 %py_dyndir              %{py_libdir}/lib-dynload
639
640 # pure python modules compilation
641 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
642
643 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
644
645 # Software written in Python language require Python with main version
646 %pyrequires_eq() Requires:      %1
647
648 # Hardlink binary identical .pyc and .pyo files
649 # (idea by glen <at> pld-linux <dot> org)
650 %__spec_install_post_py_hardlink {\
651 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
652 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
653         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
654         if cmp -s "$a" "$b"; then \
655                 ln -f "$a" "$b"; \
656         fi; \
657 done \
658 }; __spec_install_post_py_hardlink } }
659
660 # remove python sources, so that check-files won't complain
661 # (idea by glen <at> pld-linux <dot> org)
662 %py_postclean() \
663 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
664  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
665 done \
666 %{nil}
667
668 # depmod macro
669 %depmod() { \
670 umask 022; \
671 if [ -e /boot/System.map-%1 ]; then \
672         /sbin/depmod -a -F /boot/System.map-%1 %1; \
673 else \
674         if [ -e /boot/System.map ]; then \
675                 /sbin/depmod -a -F /boot/System.map %1; \
676         else \
677                 /sbin/depmod -a %1; \
678         fi \
679 fi; \
680 }
681
682 # XMMS specific macros
683 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
684 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
685 %xmms_version                   %(xmms-config --version 2>/dev/null)
686 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
687 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
688 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
689 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
690 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
691 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
692 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
693
694 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
695
696 # user/group checking macros
697 #
698 # Usage:
699 #       %userremove myuser
700 #
701 %userremove     /usr/lib/rpm/user_group.sh user del
702 %groupremove    /usr/lib/rpm/user_group.sh group del
703 #
704 # Usage:
705 #       if %usertestrm myuser; then
706 #               /usr/sbin/userdel -r myuser
707 # Note:
708 #       use these macros only if you need to call userdel/groupdel with
709 #       a non-standard option or take an extra action; otherwise use the
710 #       %userremove/%groupremove macros
711 #
712 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
713 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
714 # user group membership management macros
715 #
716 # Usage:
717 #       %addusertogroup myuser agroup
718 #
719 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
720
721 # banner support (useful in {pre,post}{,un} and triggers)
722 #
723 # Usage:
724 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
725 # the banner text, the banner text
726 # the banner text, and following line
727 #EOF
728 # You can use any form of here-document, <<'EOF' <<-EOT will do.
729 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
730 #
731 # -a   - append to the banner
732 # -e   - send to stderr instead of stdout
733 # -n   - no show banner (overrides -t)
734 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
735 %banner(aent:)  \
736 RPM_SCRIPTVERBOSITY=5 \
737 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
738 if [ -x /usr/bin/banner.sh ]; then \
739         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
740 else \
741         CMD="cat%{-e: >&2}" \
742 fi \
743 eval $CMD %2%{?3: %3} \
744 %nil
745
746 # useradd/groupadd macros
747 # Author: Elan Ruusamäe <glen@pld-linux.org>
748 #
749 # Usage:
750 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
751 #   [-g initial_group] [-G group[,...]] login
752 #
753 #  -u uid. REQUIRED
754 #  -g gid/group. REQUIRED
755 #  -s defaults to /bin/false
756 #  -d defaults to /usr/share/empty
757 #  -c No default
758 #  -r is accepted but ignored (it's always set)
759 #  -k skeleton dir. defaults to /usr/share/empty
760 # rpm specific flags
761 #  -P package name. defaults to %{name}
762 #
763 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
764 %{!-u:%{error:useradd: Required argument -u missing}} \
765 %{!-g:%{error:useradd: Required argument -g missing}} \
766 %{!?1:%{error:useradd: Required parameter login missing}} \
767 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
768         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
769                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
770                 exit 1 \
771         fi \
772 else \
773         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
774         /usr/sbin/useradd \\\
775                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
776                 -u %{-u*} \\\
777                 -r \\\
778                 -d %{-d*}%{!-d:/usr/share/empty} \\\
779                 -s %{-s*}%{!-s:/bin/false} \\\
780                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
781                 -g %{-g*} \\\
782                 %{-M} \\\
783                 %{-G:-G %{-G*}} \\\
784                 %{expand:%{%{#}}} 1>&2 || exit $? \
785         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
786 fi;
787
788 # Usage:
789 #   %groupadd [-P package] [-g gid] group
790 #
791 # -g gid. REQUIRED
792 #
793 # Sample:
794 #   %groupadd -P %{name}-base -g %{gid} %{name}
795
796 %groupadd(g:P:rfo)      \
797 %{!-g:%{error:groupadd: Required argument -g missing}} \
798 %{!?1:%{error:groupadd: Required parameter group missing}} \
799 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
800         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
801                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
802                 exit 1 \
803         fi \
804 else \
805         echo "Adding group %{1} GID=%{-g*}." \
806         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
807         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
808 fi;
809
810 # apache_config_{install/uninstall} macros *DEPRECATED*
811 # Author: Elan Ruusamäe <glen@pld-linux.org>
812 #
813 # You should use webapp macros instead. these are here until single piece of
814 # them is gone from specs ;)
815 #
816 # The config is installed/removed inside trigger, this means that you can any
817 # time install apache1 or apache package and the configuration file is updated.
818 # if you don't need the config for various reason for specific apache, just
819 # remove the symlink from apache config directory. the trigger will not put the
820 # config again to that version of apache. In other words the config is linked
821 # to apache config directory on first install of PACKAGE or apache.
822 #
823 # should be called in trigger body:
824 #  %triggerin -- apache1 >= 1.3.33-2
825 #  %apache_config_install -v 1
826 #
827 # Add package's apache config to apache config.
828 #
829 # Usage:
830 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
831 #
832 #  -v REQUIRED: specify apache version. can be 1 or 2.
833 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
834 #  -n OPTIONAL: specify config "slot". defaults to 99
835 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
836 #
837 # Internal macros. don't use ;).
838 # expands apache config dir by apache version at build time.
839 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
840 # expands apache service name by apache version at build time.
841 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
842
843 %apache_config_install(fv:c:n:) \
844 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
845 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
846 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
847         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
848 fi\
849 # reload apache if the config symlink is there\
850 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
851         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
852         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
853                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
854         fi\
855 fi\
856 %{nil}
857
858 # Remove package's apache config from apache config.
859 #
860 # Usage:
861 #   %apache_config_uninstall -v {1|2} -n 99
862 #
863 #  -v REQUIRED: specify apache version. can be 1 or 2.
864 #  -n OPTIONAL: specify config "slot". defaults to 99
865 %apache_config_uninstall(v:n:) \
866 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
867 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
868 # remove link if either of the packages are gone \
869 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
870         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
871                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
872                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
873                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
874                 fi \
875         fi \
876 fi \
877 %{nil}
878
879 # webapp macros
880 # Author: Elan Ruusamäe <glen@pld-linux.org>
881 #
882 # The config is installed/removed inside trigger, this means that you can any
883 # time install apache1/apache/lighttpd package and the configuration file is
884 # updated. if you don't need the config for various reason for specific
885 # webserver, just remove the symlink from config directory using webapp
886 # program. the trigger will not recreate the symlink on upgrades. In other
887 # words the config is linked to webserver config directory on first install of
888 # PACKAGE or WEBSERVER.
889 #
890 # Add package's webserver config to webserver webapps dir.
891 # Usage:
892 #   %webapp_register WEBSERVER WEBAPP
893 #
894 %webapp_register() \
895 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
896 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
897         /usr/sbin/webapp register %1 %2\
898 fi\
899 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
900 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
901         %{expand:%service -q %%1 reload}\
902 fi\
903 %{nil}
904
905 # Remove package's config from webserver webapps dir.
906 # Usage:
907 #   %webapp_register [-f] WEBSERVER WEBAPP
908 %webapp_unregister(f) \
909 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
910 # remove link if either of the packages are gone \
911 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
912         /usr/sbin/webapp unregister %1 %2\
913         %{expand:%service -q %%1 reload}\
914 fi \
915 %{nil}
916
917 # see browser-plugins.spec / template-browser-plugin.spec
918 # Author: Elan Ruusamäe <glen@pld-linux.org>
919 %nsplugin_install(d:f) { \
920 # create link if it's first install of either of the packages \
921 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
922 ( \
923 %( \
924         for file in %{*}; do \
925                 echo echo Installing $file to %{-d*}; \
926                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
927         done ) \
928 ) | ( %banner -t 5 -e %{name}-in ); fi; \
929 }
930
931 %nsplugin_uninstall(d:) { \
932 # remove link if either of the packages are gone \
933 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
934 ( \
935 %( \
936         for file in %{*}; do \
937                 echo echo Removing $file from %{-d*}; \
938                 echo "rm -f %{-d*}/$file;"; \
939         done ) \
940 ) | ( %banner -t 5 -e %{name}-un ); fi; \
941 }
942
943 # service macro.
944 # Author: Elan Ruusamäe <glen@pld-linux.org>
945 #
946 # calls usual service restart on package %post, but skips the restart if
947 # administrator has disabled automatic service restarts in either global
948 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
949 #
950 # Usage:
951 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
952 #
953 #  -q be silent when service isn't started (for scriplets restaring other package's services)
954 #
955 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
956
957
958 # Java macros. based on jpackage macros.java
959 #
960 # Root directory where all Java VMs/SDK/JREs are installed.
961 %_jvmdir                %{_libdir}/jvm
962
963 # Root directory where all Java VMs/SDK/JREs expose their jars
964 %_jvmjardir             %{_libdir}/jvm-exports
965
966 # Root directory for all Java VM/SDK/JRE's private things.
967 %_jvmprivdir    %{_libdir}/jvm-private
968
969 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
970 %_jvmlibdir             %{_libdir}/jvm
971
972 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
973 %_jvmdatadir    %{_datadir}/jvm
974
975 # Root directory for all configurations parts of Java VM/SDK/JRE's
976 %_jvmsysconfdir %{_sysconfdir}/jvm
977
978 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
979 %_jvmcommonlibdir       %{_libdir}/jvm-common
980
981 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
982 %_jvmcommondatadir      %{_datadir}/jvm-common
983
984 # Root directory for all common configurations parts of Java VM/SDK/JRE's
985 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
986
987 # Directory where arch-specific (JNI) version-independent jars are installed.
988 %_jnidir                %{_libdir}/java
989
990
991 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
992
993 %ant                    JAVA_HOME=%{java_home} ant
994 %jar                    %{java_home}/bin/jar
995 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
996 %javac                  %{java_home}/bin/javac
997 %javadoc                %{java_home}/bin/javadoc
998
999 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1000
1001 %jpackage_script() \
1002 install -d $RPM_BUILD_ROOT%{_bindir}\
1003 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1004 #!/bin/sh\
1005 #\
1006 # %{name} script\
1007 # JPackage Project <http://www.jpackage.org/>\
1008 \
1009 # Source functions library\
1010 . %{_javadir}-utils/java-functions\
1011 \
1012 # Source system prefs\
1013 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1014     . %{_sysconfdir}/java/%{name}.conf\
1015 fi\
1016 \
1017 # Source user prefs\
1018 if [ -f $HOME/.%{name}rc ]; then\
1019     . $HOME/.%{name}rc\
1020 fi\
1021 \
1022 # Configuration\
1023 MAIN_CLASS=%1\
1024 BASE_FLAGS=%2\
1025 BASE_OPTIONS=%3\
1026 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1027 \
1028 # Set parameters\
1029 set_jvm\
1030 set_classpath $BASE_JARS\
1031 set_flags $BASE_FLAGS\
1032 set_options $BASE_OPTIONS\
1033 \
1034 # Let's start\
1035 run "$@"\
1036 EOF
1037
1038 # PEAR install macros
1039 # Author: Elan Ruusamäe <glen@pld-linux.org>
1040 #
1041 # Usage:
1042 #       %%pear_package_setup [-a #] [-n FMT]
1043 #
1044 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1045 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1046 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1047 #
1048 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1049 # destination hierarchy. you should copy the tree to buildroot after
1050 # patching/reorganizing with %%pear_package_install.
1051 #
1052 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1053 # line endings.
1054 #
1055 # the pear install process output is recorded to install.log, you should put it
1056 # to %%doc for later debug or just for information.
1057 #
1058 # additionally additional-packages.txt is produced if it was detected that the
1059 # package has optional dependencies. the file format is suitable of displaying
1060 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1061 # automatically added for this file.
1062
1063
1064 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1065 %__pear_install_log \
1066 tee install.log \
1067 # make post message of optional packages \
1068 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1069 if [ -s optional-packages.txt ]; then \
1070         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1071 else \
1072         rm -f optional-packages.txt \
1073 fi \
1074 %{nil}
1075
1076 # command invoking pear cli
1077 %__pear /usr/bin/pear
1078
1079 # The main macro.
1080 # using this macro will append optional-packages.txt to the nocompressdoc list
1081 # as it's displayed to user after package install. and adding additional gzip
1082 # dep is just waste ;)
1083 %pear_package_setup(a:n:zD) \
1084 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1085 %define builddir %{_builddir}/%{srcdir} \
1086 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1087 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1088 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1089 %__pear \\\
1090         -c pearrc \\\
1091         -d doc_dir=/docs \\\
1092         -d php_dir=%{php_pear_dir} \\\
1093         -d bin_dir=%{_bindir} \\\
1094         -d data_dir=%{php_pear_dir}/data \\\
1095         -d test_dir=%{php_pear_dir}/tests \\\
1096         install \\\
1097         --packagingroot=%{builddir} \\\
1098         --offline \\\
1099         --nodeps \\\
1100         %{-f:--force} \\\
1101         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1102 %{-z:cd ..} \
1103 cat %{-z:$_N/}.install.log | %__pear_install_log \
1104 \
1105 # undos sources \
1106 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1107 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1108 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1109 %{nil}
1110
1111 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1112 # Author: Elan Ruusamäe <glen@pld-linux.org>
1113 %pear_package_install() \
1114 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1115 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1116 # help the developer out a little: \
1117 if [ -f _noautoreq ]; then \
1118         echo "AutoReqdep detected:" \
1119         echo "_noautoreq $(cat _noautoreq)" \
1120 fi \
1121 %{nil}
1122
1123
1124 # Register OpenLDAP schema.
1125 # Author: Elan Ruusamäe <glen@pld-linux.org>
1126 #
1127 # Usage:
1128 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1129 #
1130 #  -d specify dependant schemas, separated by comma
1131 #
1132 %openldap_schema_register(d:) \
1133 for schema in %*; do \
1134         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1135                 %{__sed} -i -e " \
1136                         /^include.*local.schema/{ \
1137                                 iinclude\\t     $schema\
1138                         } \
1139                 " /etc/openldap/slapd.conf \
1140         fi \
1141 done \
1142 # enable dependant schemas \
1143 if [ "%{-d*}" ]; then \
1144         %{__sed} -i -e ' \
1145         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1146                 s/^#// \
1147         }' /etc/openldap/slapd.conf \
1148 fi \
1149 %{nil}
1150
1151 # Unregister OpenLDAP schema.
1152 # Author: Elan Ruusamäe <glen@pld-linux.org>
1153 #
1154 # Usage:
1155 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1156 #
1157 %openldap_schema_unregister() \
1158 for schema in %*; do \
1159         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1160                 %{__sed} -i -e " \
1161                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1162                 # for symmetry it would be nice if we disable enabled schemas in post, \
1163                 # but we really can not do that, it would break something else. \
1164                 " /etc/openldap/slapd.conf \
1165         fi \
1166 done \
1167 %{nil}
1168
1169 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1170
1171
1172 # Build modules for kernels 2.6
1173 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1174 #
1175 # Usage:
1176 #       %build_kernel_modules -m <modules> -C <directory>
1177 #
1178 #  remember that proper Makefile is still required
1179 # Options:
1180 #  -m <modules> (required) -- comma-separated list of modules to save,
1181 #               without .ko extension, may be placed in subdirectory
1182 #  -C <directory> -- change to <directory> before doing anything
1183 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1184 #  -c -- do not execute make clean
1185 #  <additional arguments> -- all additional arguments will be passed to
1186 #               make modules
1187 #
1188 # Additional patching supported via here document. Try:
1189 #       %build_kernel_modules -m module <<'EOF'
1190 #       your patch script here
1191 #       EOF
1192 # Don't use it unless patching depends on config options.
1193
1194 # Developer note: don't touch it unless you know how to handle '\'.
1195 # - \ in script expands to nothing
1196 # - \\\ in script expands to \
1197 # - \\\ inside definition expands to nothing
1198 # - \\\\\\\ inside definition expands to \
1199 # - in last line \ has to touch arguments so arguments passing
1200 #   in new lines (using \) will be supported
1201
1202 %build_kernel_modules(p:P:m:C:c)                                                                        \
1203 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1204                                                                                                                                         \
1205 %define Opts                                                                                                            \\\\\\\
1206 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1207         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1208         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1209         %else                                                                                                                   \\\
1210         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1211         %endif                                                                                                                  \\\
1212 %else                                                                                                                           \\\
1213         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1214 %endif                                                                                                                          \
1215 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1216                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1217                                                                                                                                         \
1218 %{?-C:cd %{-C*}}                                                                                                        \
1219 compile() {                                                                                                                     \
1220         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1221         set -e -x                                                                                                               \
1222                                                                                                                                         \
1223 for cfg in %{?with_dist_kernel:%{?with_smp:smp} %{?with_up:up}}%{!?with_dist_kernel:nondist}; do \
1224         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1225                                                                                                                                         \
1226         rm -rf o                                                                                                                \
1227         install -d o/include/linux                                                                              \
1228         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1229         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1230         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1231 %ifarch ppc ppc64                                                                                                       \
1232         install -d o/include/asm                                                                                \
1233         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -sf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm    \
1234         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1235 %else                                                                                                                           \
1236         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1237 %endif                                                                                                                          \
1238                                                                                                                                         \
1239         set +x                                                                                                                  \
1240         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1241         set -x                                                                                                                  \
1242                                                                                                                                         \
1243         %if %{with dist_kernel}                                                                                 \
1244                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1245                         %{-p*} %{-P*}                                                                                   \\\
1246                         %{MakeOpts}                                                                                             \
1247         %else                                                                                                                   \
1248                 install -d o/include/config                                                                     \
1249                 touch o/include/config/MARKER                                                           \
1250                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1251         %endif                                                                                                                  \
1252                                                                                                                                         \
1253         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1254                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1255                 M=$PWD %{MakeOpts}}                                                                                     \
1256         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1257                 ${1+"$@"}                                                                                                       \\\
1258                 M=$PWD %{MakeOpts}                                                                                      \
1259                                                                                                                                         \
1260         for MODULE in {%{-m*},}; do                                                                             \
1261                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1262         done                                                                                                                    \
1263 done                                                                                                                            \
1264 %{?-C:cd -}                                                                                                                     \
1265 }                                                                                                                                       \
1266 compile %{*}\
1267 %{nil}
1268
1269
1270 # Install kernel modules built by %build_kernel_modules
1271 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1272 #
1273 # Usage:
1274 #       %install_kernel_modules -m <modules> -d <directory>
1275 #
1276 # Options:
1277 #  -m <modules> (required) -- comma-separated list of modules to install,
1278 #               without .ko extension, may be placed in subdirectory
1279 #  -d <directory> (required) -- in what subdirectory modules should be
1280 #               installed (eg. misc, kernel/drivers/net)
1281 #  -s <suffix> -- suffix to use when installing modules, useful when module
1282 #               with same name exists in kernel already
1283 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1284 #               for definig aliases, only useful with -s
1285
1286 %install_kernel_modules(m:d:s:n:)                                                                       \
1287 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1288 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1289 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1290                                                                                                                                         \
1291 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1292 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1293                                                                                                                                         \
1294 install -d %{KernelD}{,smp}/%{-d*}                                                                      \
1295 %{?-s:install -d %{ModprobeD}{,smp}}                                                            \
1296                                                                                                                                         \
1297 for MODULE in {%{-m*},}; do                                                                                     \
1298         [ -n "${MODULE}" ] || continue                                                                  \
1299         MNAME=${MODULE##*/}                                                                                             \
1300         %if %{without dist_kernel}                                                                              \
1301                 install ${MODULE}-nondist.ko                                                            \\\
1302                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1303                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1304                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1305         %else                                                                                                                   \
1306         %if %{with up}                                                                                                  \
1307                 install ${MODULE}-up.ko                                                                         \\\
1308                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1309                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1310                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1311         %endif                                                                                                                  \
1312         %if %{with smp}                                                                                                 \
1313                 install ${MODULE}-smp.ko                                                                        \\\
1314                         %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                   \
1315                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1316                         >> %{ModprobeD}smp/%{-n*}.conf}                                                 \
1317         %endif                                                                                                                  \
1318         %endif                                                                                                                  \
1319 done                                                                                                                            \
1320 %{nil}
1321
1322 # patchset macros
1323 # Author: Elan Ruusamäe <glen@pld-linux.org>
1324 #
1325 # Usage:
1326 #   %patchset_source -f <seq(1) format> <start> [<end>]
1327 #   %patchset_patch <start> [<end>]
1328 #
1329 # If <end> is omited, it is assumed to be <start>.
1330 #
1331 # For example in preamble:
1332 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1333 # and in %prep:
1334 #  %patchset_patch 33 44
1335
1336 # generate SourceX urls from range START STOP
1337 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1338 # The sources start from 10000
1339 %patchset_source(f:b:) %(
1340         base=%{-b*}%{!-b*:10000};
1341         start=$(expr $base + %1);
1342         end=$(expr $base + %{?2}%{!?2:%{1}});
1343         # we need to call seq twice as it doesn't allow two formats
1344         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1345         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1346         paste %{tmpdir}/__ps{1,2};
1347         rm -f %{tmpdir}/__ps{1,2};
1348 ) \
1349 %{nil}
1350
1351 # apply sources from %patchset_source
1352 # -p specify -pX for %patch line
1353 # -b base offset: defaults to 10000
1354 %patchset_patch(f:p:b:) %(
1355         base=%{-b*}%{!-b*:10000};
1356         start=$(expr $base + %1);
1357         end=$(expr $base + %{?2}%{!?2:%{1}});
1358         echo ": patchset_patch %1%{?2: to %2}";
1359         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1360 ) \
1361 %{nil}
1362
1363 # browser plugins v2
1364 # Author: Elan Ruusamäe <glen@pld-linux.org>
1365 #
1366 # Usage:
1367 #       %browser_plugins_add_browser <name> -p <plugindir>
1368 #
1369 #  <name> (required) -- name of the browser. usually %{name}.
1370 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1371 #  -b -- default blacklists
1372 #  -a <arch> override arch
1373 #
1374 # Example:
1375 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1376
1377 %_browserpluginsconfdir         /etc/browser-plugins
1378 %_browserpluginsdir                     %{_libdir}/browser-plugins
1379 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1380
1381 %browser_plugins_add_browser(p:b:a:) \
1382         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1383         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1384         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1385         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1386         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1387         %{-b:cat >> $blacklist_file %{-b*}} \
1388 %{nil}
1389
1390 # vim:ts=4 sw=4 noet syn=spec
This page took 0.307169 seconds and 3 git commands to generate.